//|------------------------------------------------------------------+
//|                                                  SOM-example.mq5 |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//|------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link		"http://www.mql5.com"
#property version	"1.00"

#property script_show_inputs

#include "SOM.mqh"
#import "shell32.dll"
   int ShellExecuteW(int hwnd, string oper, string prog, string param, string dir, int show);
#import

input string DataFileName="OptimizationReport.csv"; // data file name
input int CellsX=45; // X cells
input int CellsY=45; // Y cells
input int ImageW=780; // Image width
input int ImageH=600; // Image height
input int MaxPictures=4; // max images in row
input bool HexagonalCell=true; // hexagonal cells
input bool ShowBorders=false; // show borders
input bool ShowTitles=true; // show titles
input ColorSchemes ColorScheme=Blue_Green_Red; // gradient map used
input bool ShowProgress=false; // show progress flag (it allows to slow calculation)
input bool OpenAfterAnaliz=true; // open file with maps after finish

//------------------------------------------------------------------	OnStart
void OnStart()
{
	CSOM KohonenMap;
	MathSrand(200);
	// load training set from file
	if(!KohonenMap.LoadTrainData(DataFileName)) { Print("Error in loading of training data"); return; }
	KohonenMap.Init(10000, CellsX, CellsY, ImageW, ImageH, MaxPictures, ColorScheme, HexagonalCell, ShowBorders, ShowTitles); //  
	KohonenMap.Train(ShowProgress); // train net
	KohonenMap.Render(); // render map
	KohonenMap.ShowTrainPatterns(); // show train patterns
	KohonenMap.ShowBMP(); // show images on the chart
	if (OpenAfterAnaliz) 
		ShellExecuteW(0, "open", "explorer.exe", TerminalInfoString(TERMINAL_PATH)+"\\MQL5\\Files", TerminalInfoString(TERMINAL_PATH)+"\\MQL5\\Files", 1);
}